$nuGetPath = "nuget.exe"
$msBuildPath = "MSBuild.exe"

& $nuGetPath restore ..\ProductLaunch\ProductLaunch.sln

# publish website:
& $msBuildPath ..\ProductLaunch\ProductLaunch.Web\ProductLaunch.Web.csproj /p:OutputPath=..\..\docker\web\ProductLaunchWeb 
cp -r .\web\ProductLaunchWeb\_PublishedWebsites\ProductLaunch.Web .\web
rm -r -force .\web\ProductLaunchWeb

# publish message handlers:
& $msBuildPath ..\ProductLaunch\ProductLaunch.MessageHandlers.SaveProspect\ProductLaunch.MessageHandlers.SaveProspect.csproj /p:OutputPath=..\..\docker\save-prospect\SaveProspectHandler
& $msBuildPath ..\ProductLaunch\ProductLaunch.MessageHandlers.IndexProspect\ProductLaunch.MessageHandlers.IndexProspect.csproj /p:OutputPath=..\..\docker\index-prospect\IndexProspectHandler

# build images:
docker build -t sixeyed/msdn-web-app:v2 .\web
docker build -t sixeyed/msdn-save-handler:v2 .\save-prospect
docker build -t sixeyed/msdn-index-handler:v3 .\index-prospect